export const FormColumns = [
  {
    key: "status",
    title: "有效状态",
    inputType: "Select",
    referName: "is_effective",
    width: 100,
  },
  {
    key: "enableStatus",
    title: "启用状态",
    inputType: "Select",
    referName: "is_effective",
    width: 100,
  },
  {
    key: "puOrgName",
    title: "采购组织",
    inputType: "PopoverSelect",
    referName: "ORG_PARAM",
    valueKey: "name",
    dataMapping: {
      puOrg: "code",
      puOrgName: "name",
    },
    require: true,
  },
  {
    key: "puOrg",
    title: "采购组织编码",
    inputType: "Input",
    disabled: true,
    readonly: true,
  },
  { key: "material", title: "物料编码" },
  { key: "materialClassify", title: "物料一级分类" },
  { key: "manufacturer", title: "生产厂家" },
  { key: "materialName", title: "物料名称" },
  { key: "model", title: "物料型号" },
  { key: "specification", title: "物料规格" },
  { key: "supplier", title: "供应商" },
  {
    key: "supplierName",
    title: "供应商名称",
  },
  { key: "customer", title: "客户" },
  { key: "customerName", title: "客户名称" },
  { key: "taxPrice", title: "主含税单价" },
  { key: "unit", title: "主单位" },
  { key: "unitName", title: "主单位名称" },
  { key: "effectiveDate", title: "价格生效日期" },
  { key: "endDate", title: "价格失效日期" },
  { key: "buyer", title: "采购员" },
  { key: "buyerName", title: "采购员名称" },
  { key: "source", title: "来源单据编号" },
  { key: "convertRate", title: "换算率" },
  {
    key: "materialStatus",
    title: "物料启用状态",
    inputType: "Select",
    referName: "is_effective",
  },
  {
    key: "isDistribution",
    title: "配送价",
    inputType: "Select",
    referName: "is_effective",
  },
  {
    key: "priceType",
    title: "价格类型",
    inputType: "Select",
    referName: "sys_price_type",
  },
  { key: "demandCode", title: "采购需求单号" },
  { key: "expiryEarly", title: "效期预警" },
  { key: "priority", title: "含税/无税优先" },
  { key: "createByName", title: "创建人" },
  { key: "updateByName", title: "更新人名称" },
];

export const SearchColumns = [
  {
    key: "puOrgName",
    title: "采购组织",
    inputType: "PopoverSelect",
    referName: "ORG_PARAM",
    dataMapping: {
      puOrg: "code",
      puOrgName: "name",
    },
  },
  {
    key: "manufacturer",
    title: "生产厂家",
    inputType: "Input",
  },
  {
    key: "supplierName",
    title: "供应商",
    inputType: "PopoverSelect",
    referName: "SUPPLIER_PARAM",
    dataMapping: {
      supplier: "code",
      supplierName: "name",
    },
  },
  { key: "source", title: "来源单据编号", inputType: "Input" },
  { key: "material", title: "物料编码", inputType: "Input" },
  {
    key: "status",
    title: "有效状态",
    inputType: "Select",
    referName: "is_effective",
  },
  {
    key: "enableStatus",
    title: "启用状态",
    inputType: "Select",
    referName: "is_effective",
  },
];

export default { FormColumns, SearchColumns };
