export const TableColumns = [
  { key: "supplier", title: "供应商" },
  { key: "supplierName", title: "供应商名称" },
  { key: "puOrg", title: "采购组织" },
  { key: "puOrgName", title: "采购组织名称" },
  { key: "customer", title: "客户" },
  { key: "customerName", title: "客户名称" },
  {
    key: "priceType",
    title: "价格类型",
    inputType: "Select",
    referName: "sys_price_type",
  },
  {
    key: "isDistribution",
    title: "配送价",
    inputType: "Select",
    referName: "sys_yes_no",
  },
  { key: "effectiveDate", title: "价格生效日期" },
  { key: "endDate", title: "价格失效日期" },
  { key: "tax", title: "税率" },
  { key: "taxFreePrice", title: "无税单价" },
  { key: "taxPrice", title: "主含税单价" },
  {
    key: "purchaseQuantity",
    title: "本次采购数量",
    inputType: "InputNumber",
    width: 200,
    min: (prop) => 0,
    max: (prop) => prop.puQty - (prop.executeQty || 0),
    controlsPosition: "right",
  },
  {
    key: "arrivalDatePlan",
    title: "计划到货日期",
    inputType: "DatePicker",
    valueFormat: "yyyy-MM-dd",
    width: 200,
    pickerOptions: {
      disabledDate(time) {
        return time.getTime() < Date.now();
      },
    },
  },
  { key: "note", title: "备注", inputType: "Textarea", width: 200 },
];
